summaryrefslogtreecommitdiff
path: root/herbstluftwm/autostart
diff options
context:
space:
mode:
Diffstat (limited to 'herbstluftwm/autostart')
-rwxr-xr-xherbstluftwm/autostart186
1 files changed, 186 insertions, 0 deletions
diff --git a/herbstluftwm/autostart b/herbstluftwm/autostart
new file mode 100755
index 0000000..444d17a
--- /dev/null
+++ b/herbstluftwm/autostart
@@ -0,0 +1,186 @@
+#!/bin/bash
+
+# this is a simple config for herbstluftwm
+
+# https://bbs.archlinux.org/viewtopic.php?id=128646
+#hc() {
+# herbstclient "$@"
+#}
+hc() {
+ cmd+=(, $@)
+}
+
+mvrs() {
+ ~/.config/herbstluftwm/mvrs.sh $1 $2
+}
+
+hc emit_hook reload
+
+# Some autostart configuration
+nitrogen --restore &
+#compton -b
+
+# remove all existing keybindings
+hc keyunbind --all
+
+# keybindings
+# if you have a super key you will be much happier with Mod set to Mod4
+#Mod=Mod1 # Use alt as the main modifier
+Mod=Mod4 # Use the super key as the main modifier
+
+hc keybind $Mod-Shift-q quit
+hc keybind $Mod-Shift-r reload
+hc keybind $Mod-Shift-c close
+#hc keybind $Mod-Return spawn st
+hc keybind $Mod-Return spawn xterm
+#hc keybind $Mod-p spawn dmenu_run -b -p $(hostname) -nb "#010101"
+hc keybind $Mod-p spawn rofi -show run
+
+# basic movement
+# focusing clients
+hc keybind $Mod-h focus left
+hc keybind $Mod-j focus down
+hc keybind $Mod-k focus up
+hc keybind $Mod-l focus right
+
+# moving clients
+hc keybind $Mod-Shift-h shift left
+hc keybind $Mod-Shift-j shift down
+hc keybind $Mod-Shift-k shift up
+hc keybind $Mod-Shift-l shift right
+
+# splitting frames
+# create an empty frame at the specified direction
+hc keybind $Mod-u split bottom 0.5
+hc keybind $Mod-o split right 0.5
+# let the current frame explode into subframes
+hc keybind $Mod-Control-space split explode
+
+# resizing frames
+resizestep=0.02
+hc keybind $Mod-Control-h spawn ~/.config/herbstluftwm/mvrs.sh left +$resizestep
+hc keybind $Mod-Control-j spawn ~/.config/herbstluftwm/mvrs.sh down +$resizestep
+hc keybind $Mod-Control-k spawn ~/.config/herbstluftwm/mvrs.sh up +$resizestep
+hc keybind $Mod-Control-l spawn ~/.config/herbstluftwm/mvrs.sh right +$resizestep
+hc keybind $Mod-Control-Left resize left +$resizestep
+hc keybind $Mod-Control-Down resize down +$resizestep
+hc keybind $Mod-Control-Up resize up +$resizestep
+hc keybind $Mod-Control-Right resize right +$resizestep
+
+# tags
+#tag_names=( {1..9} )
+tag_names=( "web" "editors" "chat" "games" "misc" )
+tag_keys=( {1..9} 0 )
+
+hc rename default "${tag_names[0]}" || true
+for i in ${!tag_names[@]} ; do
+ hc add "${tag_names[$i]}"
+ key="${tag_keys[$i]}"
+ if ! [ -z "$key" ] ; then
+ hc keybind "$Mod-$key" use_index "$i"
+ hc keybind "$Mod-Shift-$key" move_index "$i"
+ fi
+done
+
+hc floating "games" on
+
+# cycle through tags
+hc keybind $Mod-period use_index +1 --skip-visible
+hc keybind $Mod-comma use_index -1 --skip-visible
+
+# layouting
+hc keybind $Mod-r remove
+hc keybind $Mod-space cycle_layout 1
+hc keybind $Mod-s floating toggle
+hc keybind $Mod-f fullscreen toggle
+hc keybind $Mod-Shift-p pseudotile toggle
+
+# Light and sound
+hc keybind $Mod-Left spawn xbacklight -5
+hc keybind $Mod-Down spawn amixer set Master 3-
+hc keybind $Mod-Up spawn amixer set Master 3+
+hc keybind $Mod-Right spawn xbacklight +5
+
+# mouse
+hc mouseunbind --all
+hc mousebind $Mod-Button1 move
+hc mousebind $Mod-Button2 zoom
+hc mousebind $Mod-Button3 resize
+
+# focus
+hc keybind $Mod-BackSpace cycle_monitor
+hc keybind $Mod-Tab cycle_all +1
+hc keybind $Mod-Shift-Tab cycle_all -1
+hc keybind $Mod-c cycle
+hc keybind $Mod-i jumpto urgent
+
+# theme
+#hc attr theme.tiling.reset 1
+#hc attr theme.floating.reset 1
+#hc set frame_border_active_color '#9E003A'
+#hc set frame_border_normal_color '#101010'
+#hc set frame_bg_normal_color '#565656'
+#hc set frame_bg_active_color '#000000'
+#hc set frame_border_width 2
+#hc set always_show_frame 1
+hc set frame_bg_transparent 1
+hc set frame_transparent_width 1
+hc set frame_gap 2
+hc set frame_border_active_color '#000000'
+hc set frame_border_normal_color '#1d1f21'
+hc set frame_bg_normal_color '#151515'
+hc set frame_bg_active_color '#151515'
+hc set frame_border_width 0
+hc set window_border_width 2
+hc set window_border_normal_color '#3a3a3a'
+hc set window_border_active_color '#cc342b'
+
+#hc attr theme.active.color '#9E003A'
+#hc attr theme.normal.color '#252525'
+#hc attr theme.urgent.color orange
+#hc attr theme.inner_width 0
+#hc attr theme.inner_color '#191919'
+#hc attr theme.border_width 2
+#hc attr theme.floating.border_width 2
+#hc attr theme.floating.outer_width 3
+#hc attr theme.floating.outer_color black
+#hc attr theme.active.inner_color '#9E003A'
+#hc attr theme.active.outer_color '#111111'
+#hc attr theme.background_color '#141414'
+
+
+#hc set window_gap 0
+hc set frame_padding 0
+#hc set smart_window_surroundings 1
+#hc set smart_frame_surroundings 1
+#hc set mouse_recenter_gap 0
+
+# rules
+hc unrule -F
+#hc rule class=XTerm tag=3 # move all xterms to tag 3
+hc rule focus=on # normally focus new clients
+#hc rule focus=off # normally do not focus new clients
+# give focus to most common terminals
+#hc rule class~'(.*[Rr]xvt.*|.*[Tt]erm|Konsole)' focus=on
+hc rule windowtype~'_NET_WM_WINDOW_TYPE_(DIALOG|UTILITY|SPLASH)' pseudotile=on
+hc rule windowtype='_NET_WM_WINDOW_TYPE_DIALOG' focus=on
+hc rule windowtype~'_NET_WM_WINDOW_TYPE_(NOTIFICATION|DOCK|DESKTOP)' manage=off
+
+# unlock, just to be sure
+hc unlock
+
+herbstclient set tree_style '╾│ ├└╼─┐'
+
+# do multi monitor setup here, e.g.:
+# hc set_monitors 1280x1024+0+0 1280x1024+1280+0
+# or simply:
+# hc detect_monitors
+herbstclient chain "${cmd[@]}"
+
+# find the panel
+panel=~/.config/herbstluftwm/panel.sh
+[ -x "$panel" ] || panel=/etc/xdg/herbstluftwm/panel.sh
+for monitor in $(herbstclient list_monitors | cut -d: -f1) ; do
+ # start it on each monitor
+ "$panel" $monitor &
+done